' Faktura-Software Scriptdatei 
' Funktion: 	Lagerbuchung fr den aktuellen Beleg durchfhren
' Ansicht:  	FakturaBelege
' Script:	FakturaBelege_24_Lagerbuchung.vbs
' Produkt:	combit Relationship Manager 5
' Autor  :  	Andreas Mller

' Faktura-Software.net macht keine Angaben zu einer bestimmten Eignung der Information in diesem Script
' Irrtmer und Fehler bleiben ausdrcklich vorbehalten und die Angaben erfolgen ohne Gewhr. 
' Die Angaben stellen nur Einzelfallszenarien dar und enthalten keine Garantie der Beschaffenheit 
' der Produkte. 
 
' Copyright (c) by Faktura-Software.net. Alle Rechte vorbehalten.
'--------------------------------------------------------------------------------------------------------------


<!--#include file="%PRJDIR%\script\CosmoOle.vbs"-->



Sub Lagerbuchung()
'--------------------------------------------------------------------------------------------------------------
' Begin Versionierung
'--------------------------------------------------------------------------------------------------------------
Dim sSkriptVersion
sSkriptVersion = "001"
'--------------------------------------------------------------------------------------------------------------
' What's new
'--------------------------------------------------------------------------------------------------------------
' Version 002 
' - 
'--------------------------------------------------------------------------------------------------------------

Dim sErrorCode, sErrorProjekt, sErrorAnsicht, sErrorSkript

sErrorProjekt   = cRM.CurrentProject.GetSessionProperty("cRM_Projekt_ProjektNr",True)
sErrorAnsicht   = "118"
sErrorSkript    = "024"

sErrorCode =  sErrorProjekt & sErrorAnsicht & sErrorSkript

'--------------------------------------------------------------------------------------------------------------
' Ende Versionierung
'--------------------------------------------------------------------------------------------------------------


'---------------------------------------------------------------------------------------------------------------------------
'Globale Parameter auslesen
'---------------------------------------------------------------------------------------------------------------------------
 Dim sLagerbuchMengeKomplett,bKomplettBuchen

 
 sLagerbuchMengeKomplett = GetHiddenFieldContentByName("FakturaGlobaleEinstellungen","upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'LagerBuchMengeKomplett')","Result","Der Eintrag konnte nicht gefunden werden")
	     
 If sLagerbuchMengeKomplett ="Ja" Then
   bKomplettBuchen = True
 Else 
   bKomplettBuchen = False
 END If


 Dim sLagerBuchSnEingeben,bSnEingeben
 sLagerBuchSnEingeben = GetHiddenFieldContentByName("FakturaGlobaleEinstellungen","upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'LagerBuchSeriennummerEingeben')","Result","Der Eintrag konnte nicht gefunden werden")
	     
 If sLagerBuchSnEingeben ="Ja" Then
   bSnEingeben = True
 Else 
   bSnEingeben = False
 END If


'---------------------------------------------------------------------------------------------------------------------------
'/ Globale Parameter auslesen
'---------------------------------------------------------------------------------------------------------------------------



'---------------------------------------------------------------------------------------------------------------------------
' Datensatz-Informationen auslesen
'---------------------------------------------------------------------------------------------------------------------------
Dim sErfuser, sBeleg_Recordid,oRecordSet,oRecord,sFilterBuchPos,bFilter,sBeleg_Groupid

'Objekte initialisieren
Set oRecordSet = cRM.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet 

Set oRecord = oRecordSet.CurrentRecordSynchronized
' / Objekte initialisieren

sBeleg_Recordid = oRecord.GetContentsByName("Recordid")
sErfuser           =  cRM.CurrentProject.CurrentUser
sBeleg_Groupid  = oRecord.GetContentsByName("GroupID")

Set oRecordSet = Nothing
Set oRecord     = Nothing






'---------------------------------------------------------------------------------------------------------------------------
'Datensatz exklusiv verwenden
'Eine Buchung kann nur stattfinden, wenn es fr diesen Beleg keinen Lagerprotokolleintrag mit Status "Lagerbuchungsposition" gibt.
'---------------------------------------------------------------------------------------------------------------------------

Set oRecordSet = cRM.CurrentProject.ViewConfigs.ItemByName("FakturaLagerprotokoll").CreateRecordSet

sFilterBuchPos = """Factura_Lagerprotokoll"".""Beleg_Recordid"" = 0x" & sBeleg_Recordid _
                    & " AND upper(""Factura_Lagerprotokoll"".""Status"") = upper(N'Lagerbuchungsposition')"

bFilter = oRecordSet.SetFilter(sFilterBuchPos)
  
  if bFilter = True then 'Filter korrekt
      'Prfung - gibt es bereits Lagerbuchungspositionen?
      if oRecordSet.MoveFirst Then 'Lagerbuchungspositionen bereits vorhanden - Script beenden
          
          showmessage("Dieser Beleg befindet sich gerade in der Buchung!" & vblf & "Der Vorgang wurde abgebrochen.")
	  Set oRecordSet = Nothing
	  Wscript.Quit
      END IF
  ELSE 'Filter nicht korrekt
    RaiseException("ErrorCode:" & sErrorCode & "001" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
    Set oRecordSet = Nothing
    Wscript.Quit
  END IF
  
Set oRecordSet = Nothing
sFilterBuchPos = ""
'---------------------------------------------------------------------------------------------------------------------------
'/ Datensatz exklusiv bearbeiten
'---------------------------------------------------------------------------------------------------------------------------


'---------------------------------------------------------------------------------------------------------------------------
' Lagerfhige Positionen in Buchungsliste bertragen
'--------------------------------------------------------------------------------------------------------------------------- 
Dim sProcedure, sTrennzeichen, sParameter,bSP
 
 
 sProcedure = "Fs_Lagerbuchung_Temp"
 sTrennzeichen = ";"
 sParameter = sBeleg_Recordid & ";" & sErfuser
 bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "001"))

if bSP = false THEN
      'RaiseException("ErrorCode:" & sErrorCode & "001" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
      Wscript.Quit
End If


'---------------------------------------------------------------------------------------------------------------------------
' Lagerprfung
' Vergleiche die Anzahl der zu buchenden Datenstze mit der Anzahl der Datenstze, fr die Lagerpositionen existieren
' Der Vergleich wird unabhngig von der verfgbaren Artikelmenge gefhrt.
'--------------------------------------------------------------------------------------------------------------------------- 
Dim iAnzahl_Ds,iAnzahl_Lagerpos
Set oRecordSet = cRM.CurrentProject.ViewConfigs.ItemByName("FakturaLagerprotokoll").CreateRecordSet

'Filter 1: alle Datenstze
sFilterBuchPos = """Factura_Lagerprotokoll"".""Beleg_Recordid"" = 0x" & sBeleg_Recordid _
                    & " AND upper(""Factura_Lagerprotokoll"".""Status"") = upper(N'Lagerbuchungsposition')"


bFilter = oRecordSet.SetFilter(sFilterBuchPos)
  
if bFilter = True then 'Filter korrekt
    iAnzahl_Ds = oRecordSet.Reccount
    
END IF

'Filter 2: alle Datenstze, die buchbar sind
sFilterBuchPos = """Factura_Lagerprotokoll"".""Beleg_Recordid"" = 0x" & sBeleg_Recordid _
                    & " AND upper(""Factura_Lagerprotokoll"".""Status"") = upper(N'Lagerbuchungsposition')"_
		    & "AND ""Factura_Lagerprotokoll"".""Lager_Recordid"" IS NOT NULL"

bFilter = oRecordSet.SetFilter(sFilterBuchPos)
  
if bFilter = True then 'Filter korrekt
    iAnzahl_Lagerpos = oRecordSet.Reccount
END IF
Set oRecordSet = Nothing


if iAnzahl_Ds > iAnzahl_Lagerpos Then 'Vergleich
  
   IF MsgBox("Eine vollstndige Buchung ist nicht mglich, da nicht fr jeden Artikel Lagerpositionen zur Buchung bestehen. Sollen fr die fehlenden Artikel Lagerpositionen im Wareneingangslager zugeordnet werden?",vbQuestion + vbYesNo, "Lagerplatz fr Artikel zuweisen") = vbYES Then 'Initialbestand anlegen?
      
      '---------------------------------------------------------------------------------------------------------------------------
	' Initialbestand anlegen
	' Es wird fr jeden Artikel, der keine Lagerzuordnung hat, ein Initialbestand angelegt.
      '--------------------------------------------------------------------------------------------------------------------------- 
      
      sProcedure = "Fs_Artikel_Initialbestand"
      sTrennzeichen = ";"
      sParameter =  sErfuser & ";" & sBeleg_Recordid
     
      bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "002"))

      if bSP = false Then
        'RaiseException("ErrorCode:" & sErrorCode & "002" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
	Set oRecordset = Nothing
        Set oRecord     = Nothing
        Wscript.Quit
      End If
    
   ELSE 'Initialbestand nicht anlegen
   
         
     '---------------------------------------------------------------------------------------------------------------------------
	' Vorgang Beenden
	' Lsche alle Lagerbuchungspositionen 
      '--------------------------------------------------------------------------------------------------------------------------- 

	Lagerbuchung_Beenden sBeleg_Recordid,sErfuser
   
   
   END If '/Initialbestand anlegen?
   
    
END IF ' / Vergleich
'---------------------------------------------------------------------------------------------------------------------------
' Logik fr Seriennummern 
'---------------------------------------------------------------------------------------------------------------------------

   '---------------------------------------------------------------------------------------------------------------------------
   ' Seriennummern einfgen
   '---------------------------------------------------------------------------------------------------------------------------
   Set oRecordSet = cRM.CurrentProject.ViewConfigs.ItemByName("FakturaLagerprotokoll").CreateRecordSet
  
  'Positionen / Menge auslesen
   Dim sFilterSN, sLagerprotokoll_Recordid,sSN_Anzahl, sArtikelnr,sFilterSnZuord,oSnRecordSet,sSn_Recordid,sSn_Eingabe,iZaehler

   
   sFilterSN = """Factura_Lagerprotokoll"".""Beleg_Recordid"" = 0x" & sBeleg_Recordid _
                    & " AND upper(""Factura_Lagerprotokoll"".""Status"") = upper(N'Lagerbuchungsposition')" _
		    & " AND ""Factura_Lagerprotokoll"".""Text_Temp"" is not Null"

   bFilter = oRecordSet.SetFilter(sFilterSN)
  
   If bFilter = True then 'Filter Seriennummern korrekt
      'Prfung - gibt es Positionen
      If  oRecordSet.MoveFirst Then 'Seriennummern erzeugen und hinterlegen
         
        Showmessage(oRecordSet.Reccount & " Seriennummern-fhige Position(en) vorhanden")
 
         Do 'Seriennummern-Buchung
        'Gehe alle Datenstze durch erzeuge und hinterlege die Seriennummern
           Set oRecord = oRecordSet.CurrentRecordSynchronized 
	       
	       sLagerprotokoll_Recordid  = oRecord.GetContentsByName("Recordid")
	       sArtikelnr                = oRecord.GetContentsByName("Artikelnr")
	       sSN_Anzahl                = oRecord.GetContentsByName("Menge")
	       
	       sSN_Anzahl = Stringreplace(sSN_Anzahl,".",",") 
           sSN_Anzahl = FormatNumber(sSN_Anzahl,2,-1,0,-1)
        
	       If sSN_Anzahl = "" Or sSN_Anzahl = Null Then
	         sSN_Anzahl = 0
	       End If
	       
	       Do 
	        'showmessage("Debug: " & sArtikelnr & " | " & sSN_Anzahl)
	        
	        
	        
	        If bSnEingeben Then ' Seriennummern Parametrisiert
	        
	        		'-------------------------------------
			        ' Seriennummern ausschliesslich  eingeben
			        '-------------------------------------
	                   sSn_Eingabe = ""
			           
			            sSn_Eingabe = inputBox("Fr Artikel " & sArtikelnr & " muss eine Seriennummer vergeben werden: ","Es werden noch " & sSN_Anzahl & " Seriennummern bentigt")
		                
		                If sSn_Eingabe = "" Or sSn_Eingabe = Null Then 'Eingabe prfen
			               If MsgBox("Keine Eingabe. Lagerbuchung abbrechen?",vbQuestion + vbYesNo, "Seriennummern zu Beleg_Positionen zuweisen") = vbYes Then 
		        				Set oRecord      = Nothing
		        				Set oSnRecordSet = Nothing
		        				Lagerbuchung_Beenden sBeleg_Recordid,sErfuser
			               End If
			             Else ' Eingabe prfen
			                sProcedure = "Fs_Lagerbuchung_Sn_Erzeugen_Und_Zuordnen"
		      				sTrennzeichen = ";"
		      				sParameter =  sLagerprotokoll_Recordid & ";" & sSn_Eingabe & ";" & sErfuser
		
		      				bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "099"))
		                     
		      				If bSP = False Then
		        				'RaiseException("ErrorCode:" & sErrorCode & "099" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
								Set oRecordset   = Nothing
		        				Set oRecord      = Nothing
		        				Set oSnRecordSet = Nothing
		        				Lagerbuchung_Beenden sBeleg_Recordid,sErfuser
		      				Else 
		      				  sSN_Anzahl = sSN_Anzahl - 1
		      				End If
		                  
		                  
			             End If '/Eingabe prfen
		                
	        		'-------------------------------------
			        ' / Seriennummern ausschliesslich  eingeben
			        '-------------------------------------
	        
	          Else ' Seriennummern parametrisiert
	        
			        '-------------------------------------
			        ' Seriennummern auswhlen und eingeben
			        '-------------------------------------
			        
			        'Prfe, ob freie Seriennummern vorhanden
			         sFilterSnZuord = "upper(""Factura_Seriennummer"".""Artikelnr"") = upper(N'"& sArtikelnr & "') AND (""Factura_Seriennummer"".""Verwendet"" = 0 OR ""Factura_Seriennummer"".""Verwendet"" IS NULL)"
			        
			         Set oSnRecordSet = cRM.CurrentProject.ViewConfigs.ItemByName("FakturaArtikel_Seriennummer").CreateRecordSet
			        
			         bFilter = oSnRecordSet.SetFilter(sFilterSnZuord)
			         
			         If bFilter = True Then 'SN_Filter ok
			         
			         	If oSnRecordSet.MoveFirst Then 'Seriennummer auswhlen
			             	'showmessage("SN aus Liste auswhlen")
			             	sSn_Recordid = OpenDialogSelectRecordDontQuit("FakturaArtikel_Seriennummer",sFilterSnZuord,"Recordid","Seriennummer auswhlen zu Artikel: " & sArtikelnr & ". Es werden noch " & sSN_Anzahl & " Seriennummern bentigt" ,"Keine Seriennummer ausgewhlt")     
			            End If 'Seriennummer auswhlen
			                 
			                If sSn_Recordid = "" Or sSn_Recordid = Null Then 'Auswahl prfen
			                   
			                   If MsgBox("Keine Auswahl. Mchten Sie die Seriennummer stattdessen eingeben?",vbQuestion + vbYesNo, "Seriennummern zu Beleg_Positionen zuweisen") = vbNo Then 
		                         Set oRecordset   = Nothing
		        			     Set oRecord      = Nothing
		        			     Set oSnRecordSet = Nothing
		        			     Lagerbuchung_Beenden sBeleg_Recordid,sErfuser
		        			   Else 
		        			     bSnEingeben = True
			                   End If
			                   
			                Else ' Auswahl prfen
			                
			                   sProcedure = "Fs_Lagerbuchung_Sn_Zuordnen"
		      				   sTrennzeichen = ";"
		      				   sParameter =  sLagerprotokoll_Recordid & ";" & sSn_Recordid & ";" & sErfuser
		
		      				   bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "099"))
		                     
		      				   if bSP = False Then
		        				   'RaiseException("ErrorCode:" & sErrorCode & "099" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
								   Set oRecordset   = Nothing
		        				   Set oRecord      = Nothing
		        				   Set oSnRecordSet = Nothing
		        				   Lagerbuchung_Beenden sBeleg_Recordid,sErfuser
		        		       Else 
		        		           sSN_Anzahl = sSN_Anzahl - 1
		      				   End If
		                  
			                End If '/Auswahl prfen
	                   
			         End If '/ SN-Filter Ok
			        
			        '-------------------------------------
			        ' / Seriennummern auswhlen und eingeben
			        '-------------------------------------

	       End If ' Seriennummern parametrisiert
	       
	       
	
	 Loop Until sSN_Anzahl = 0 ' / Schleife pro Position
	
	
	        'nchste Position wieder auf Ausgangswert fr Buchung nach Parameter setzen
	        If sLagerBuchSnEingeben ="Ja" Then
			   bSnEingeben = True
			Else 
			   bSnEingeben = False
			END If
	       
	       
	       
        Loop Until Not oRecordSet.MoveNext ' / Seriennummern-Buchung
	
	showmessage("Seriennummern wurden gebucht")
	Else
	  'Showmessage("Keine Seriennummern zu buchen")
     END IF ' / Seriennummern erzeugen und hinterlegen
  END IF' / Filter Seriennummern Korrekt




'---------------------------------------------------------------------------------------------------------------------------
' /Logik fr Seriennummern 
'---------------------------------------------------------------------------------------------------------------------------


'---------------------------------------------------------------------------------------------------------------------------
' Lagerbuchung
'--------------------------------------------------------------------------------------------------------------------------- 
Dim sFilterLager,oLagerRecordSet,sLagerRecordid,iAbbuchMenge,iRestmenge,sPosnr,sPosnr2,bfertig,sLagerZuordRecordid

Dim sFilterArtikelBestand,iArtikelBestand,sBuchungsText,sFilterLagerMenge,sBelegpos_Recordid

'Fr Meldebestand
Dim iMeldebestand, iArtikelBestandNeu,sFilterArtikel,iAnz_Bestellv,iAnz_Zulauf,bBestellvorschlag,iBestellMenge,sFrage,bProduktionsartikel,bProduktionsauftrag

'Fr Produktion
Dim iProdmenge,iProdzeit,iHerstellbar,sUnique,bProduzierbar,oRecordSetProdukt,oRecordProdukt,sArtikelbez

Set oRecordSet = cRM.CurrentProject.ViewConfigs.ItemByName("FakturaLagerprotokoll").CreateRecordSet

Set oLagerRecordSet = cRM.CurrentProject.ViewConfigs.ItemByName("FakturaLagerzuordnung").CreateRecordSet

sFilterBuchPos = """Factura_Lagerprotokoll"".""Beleg_Recordid"" = 0x" & sBeleg_Recordid _
                    & " AND upper(""Factura_Lagerprotokoll"".""Status"") = upper(N'Lagerbuchungsposition')"_
		    & "AND ""Factura_Lagerprotokoll"".""Lager_Recordid"" IS NOT NULL"

bFilter = oRecordSet.SetFilter(sFilterBuchPos)
 
  
if bFilter = True then 'Filter korrekt

  If oRecordSet.MoveFirst Then  'Datenstze zum Buchen vorhanden
  
    'Showmessage(oRecordSet.Reccount & " Lagerfhige Positionen vorhanden")
    
    Do 'Lagerbuchung
    
       Set oRecord = oRecordSet.CurrentRecordSynchronized
       
       'Artikelnummer und weitere Felder des aktuellen Ds auslesen
       sArtikelnr    		  =oRecord.GetContentsByName("Artikelnr")
       sArtikelbez		=oRecord.GetContentsByName("Bezeichn1")
       iRestmenge 		  = oRecord.GetContentsByName("Menge_Temp")
       sPosnr        	  = oRecord.GetContentsByName("Posnr_Temp")
       sPosnr2       	  = oRecord.GetContentsByName("Posnr2_Temp")
       sBelegpos_Recordid = oRecord.GetContentsByName("Beleg_Position_Recordid")
       
        iRestmenge = Stringreplace(iRestmenge,".",",") 
        iRestmenge =FormatNumber(iRestmenge,2,-1,0,-1)
      
      
       'Filter fr Lagerpltze mit der Artikelnummer
       SFilterLager = "upper(""Factura_Lagerzuordnung"".""Artikelnr"") = upper(N'" & sArtikelnr   & "')"
       
       
       do while iRestmenge > 0 'Buchen
         'berhaupt Lger vorhanden?
	 oLagerRecordSet.SetFilter(sFilterLager)

         If oLagerRecordSet.MoveFirst Then  'Lager fr diesen Artikel vorhanden
	 
	    ' ----------------------------------------------------------------------------------
	    ' | Wenn nur ein Lagerplatz vorhanden ist, buche die komplette Position ohne Abfrage |
	    '-----------------------------------------------------------------------------------
            
	    ' ----------------------------------------------------------------------------------
	    ' | buche die komplette Position ohne Abfrage |
	    '-----------------------------------------------------------------------------------
	    if oLagerRecordSet.Reccount = 1 Then 'Nur ein Lagerplatz vorhanden = direkt und vollstndig bernehmen
	       sLagerZuordRecordid = oLagerRecordSet.CurrentRecordSynchronized.GetContentsByName("Recordid")
	       
	       If sLagerZuordRecordid ="" Then   'Wenn Eingabe abgebrochen wurde - Script sauber beenden 
             	    showmessage("Vorgang abgebrochen.Bitte fhren Sie Lagerbuchung erneut aus.")
		    'Prozedur: Sauber beenden
		    Lagerbuchung_Beenden sBeleg_Recordid,sErfUser    
                End If   ' / Wenn Eingabe abgebrochen wurde - Script sauber beenden 
		
	      'Lager_Recordid ermitteln 
	      sFilterLagerMenge = """Factura_Lagerzuordnung"".""Recordid"" = 0x" & sLagerZuordRecordid
	      
	      sLagerRecordid = GetHiddenFieldContentByName("FakturaLagerzuordnung",sFilterLagerMenge ,"Lager_Recordid", "Das Lager konnte nicht gefunden werden.")
	      
	      iAbbuchmenge = iRestmenge
	      
	       sProcedure    = "Fs_Lagerbuchung_Insert"
   	       sTrennzeichen = ";"
   	       sParameter    = sLagerRecordid & ";" & sBeleg_Recordid & ";" & sBelegpos_Recordid & ";" & sArtikelnr & ";" & iAbbuchmenge & ";" &  sErfuser & ";" &  sLagerZuordRecordid
                
	       bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "005"))
	      
	       if bSP = false THEN
	       
	       
		       'RaiseException("ErrorCode:" & sErrorCode & "005" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
		       Wscript.Quit
		     End If
		    
		 iRestmenge = 0
	        
		
		   
	    ELSE ' - Nur ein Lagerplatz vorhanden = direkt und vollstndig bernehmen
	   ' -----------------------------------------------------------------------------------
	    ' | Prfung: Wenn LagerBuchMengeKomplett in Factura_Software_Global = ja             |
	    ' |              dann komplette Menge auf einmal buchen                                           |
	    '-----------------------------------------------------------------------------------
	   
	    
	    
	    'Artikelbestand ermitteln 
	    sFilterArtikelBestand="upper(""v_Factura_Artikel_Lagermengen"".""Artikelnummer"") = upper(N'" &sArtikelnr &"')"
	
	    
	
	    iArtikelBestand = GetHiddenFieldContentByName("v_FakturaArtikel_Lagermenge",sFilterArtikelBestand,"Menge","Der Artikel konnte nicht gefunden werden")
	    
	    'Lagerbuchungstext
	    sBuchungstext = "Lagerbuchung fr Artikel " & sArtikelnr & " , Position " & sPosnr & "." & sPosnr2 & " ,Gesamtbestand: " & iArtikelbestand & " | bentigt: " & iRestmenge 
	    
	    
	    sLagerZuordRecordid = OpenDialogSelectRecordDontQuit("FakturaLagerzuordnung",sFilterLager,"Recordid",sBuchungsText,"Kein Artikel ausgewhlt")
	    
	    If sLagerZuordRecordid ="" Then   'Wenn Eingabe abgebrochen wurde - Script sauber beenden 
             	    showmessage("Vorgang abgebrochen.Bitte fhren Sie Lagerbuchung erneut aus.")
		    
		    'Prozedur: Sauber beenden
		    Lagerbuchung_Beenden sBeleg_Recordid,sErfUser
		    
		    
            End If   ' / Wenn Eingabe abgebrochen wurde - Script sauber beenden 
	    
	    'Wird derzeit nicht bentigt 
	    sFilterLagerMenge = """Factura_Lagerzuordnung"".""Recordid"" = 0x" & sLagerZuordRecordid
	    
	    
	    If bKomplettBuchen Then  ' Komplette Buchung oder in Teilen
	     
	       iAbbuchMenge = iRestmenge
	    
	    Else ' - Komplette Buchung oder in Teilen
	    
	      'Menge zum Abbuchen
	      iAbbuchMenge = ZahlEingeben("Wie viele Artikel " & sArtikelnr & " sollen aus dem Lager entnommen werden: ","Es werden noch " & iRestmenge & "Artikel bentigt", iRestmenge)
	      'iAbbuchMenge = inputBox("Wie viele Artikel " & sArtikelnr & " sollen aus dem Lager entnommen werden: ","Es werden noch " & iRestmenge & "Artikel bentigt"  ,iRestmenge) 
	      
	    END IF ' / Komplette Buchung oder in Teilen
	   
	     
	     if iAbbuchmenge = false then 'Lagerbuchung_Temp rckgngig machen
	        sProcedure    = "Fs_Lagerbuchung_Temp_Delete"
                sTrennzeichen = ";"
                sParameter    = sBeleg_Recordid & ";" & sErfuser
    	 	     
                bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "010"))
   
		if bSP = false THEN  
		   'RaiseException("ErrorCode:" & sErrorCode & "010" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
		   Set oLagerRecordSet = Nothing
		   Set oRecordSet 	 = Nothing
		   Set oRecord      	 = Nothing
             	   WScript.Quit
		End if
	     
	        Set oLagerRecordSet = Nothing
	        Set oRecordSet        = Nothing
                Set oRecord             = Nothing
                WScript.Quit
	    END IF '/Lagerbuchung_Temp rckgngig machen
	     
	     
	   ' If iAbbuchMenge = 0 or iAbbuchmenge = "" then
	   '     AbbuchMenge = 0 
	   '  End If
     
	      'Eingabe auf negativ prfen 
	      If iAbbuchMenge < 0 Then
	        Msgbox("Bitte nur positive Zahlenwerte eingeben.")
	        iAbbuchMenge = 0
	      End If
	      
	    
		
	       'Abbuchung grer der bentigten Menge -> Abbuchung = bentigte Menge
	      If cdbl(iAbbuchMenge) > cdbl(iRestmenge) Then	  
                iAbbuchMenge = iRestmenge
		'Wert formatieren
		iAbbuchMenge = Stringreplace(iAbbuchMenge,".",",")
	        iAbbuchMenge =FormatNumber(iAbbuchMenge,2,-1,0,-1)
		
		
             End If
	     'Lager_Recordid ermitteln 
	      sLagerRecordid = GetHiddenFieldContentByName("FakturaLagerzuordnung",sFilterLagerMenge ,"Lager_Recordid", "Das Lager konnte nicht gefunden werden.")
	      
	      sProcedure    = "Fs_Lagerbuchung_Insert"
   	      sTrennzeichen = ";"
   	      sParameter    = sLagerRecordid & ";" & sBeleg_Recordid & ";" & sBelegpos_Recordid & ";" & sArtikelnr & ";" & iAbbuchMenge & ";" &  sErfuser & ";" &  sLagerZuordRecordid
              'showmessage(sProcedure & " | " & sParameter)
	      bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "005"))
	      
	      if bSP = false THEN
		      'RaiseException("ErrorCode:" & sErrorCode & "005" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
		      Wscript.Quit
		    End If
		    
		iRestmenge = iRestmenge - iAbbuchMenge 
             
	     END IF  ' / Nur ein Lagerplatz vorhanden = direkt und vollstndig bernehmen
	 ELSE 'Lager fr diesen Artikel nicht vorhanden
	 
	   'Vorgang abbrechen und alle Buchungen rckgngig machen
	   showmessage("fr den Artikel " &sArtikelnr & "gibt es kein Lager - Bitte fhren Sie Lagerbuchung erneut aus.")
    
		Lagerbuchung_Beenden sBeleg_Recordid,sErfUser   
		    
         END IF 'Lager fr diesen Artikel vorhanden
	 
	 
       Loop 'Buchen
       
       '---------------------------------------------------------------------------------------------------------------------------
	'Prfung: Meldebestand unterschritten?
	'---------------------------------------------------------------------------------------------------------------------------
        IF iRestmenge = 0 then 'Meldebestand prfen
	
	  
	 
	    'showmessage(bProduktionsartikel)
	   iMeldebestand = GetHiddenFieldContentByName("v_FakturaArtikel_Lagermenge",sFilterArtikel,"Meldebestand","Der Artikel konnte nicht gefunden werden")
	   
	    ' iMeldebestand = Stringreplace(iMeldebestand,".",",")
	    ' iMeldebestand =FormatNumber(iMeldebestand,2,-1,0,-1)
	   
	   iArtikelBestandNeu = GetHiddenFieldContentByName("v_FakturaArtikel_Lagermenge",sFilterArtikel,"Anz_Verfuegbar","Der Artikel konnte nicht gefunden werden")
	  
	     ' iArtikelBestandNeu = Stringreplace(iArtikelBestandNeu,".",",")
	     ' iArtikelBestandNeu =FormatNumber(iArtikelBestandNeu,2,-1,0,-1)
	 
	  'showmessage(iArtikelBestandNeu & " | " & iMeldebestand)
	   If cdbl(iArtikelBestandNeu) <= cdbl(iMeldebestand) Then 'Meldebestand unterschritten
	     showmessage("Meldebestand fr Artikel " & sArtikelnr & " | " & left(sArtikelbez,30) & ".. unterschritten")
	     
	      'Grundeinstellung: Bestellvorschlag anlegen
	      bBestellvorschlag  = true
	     
	      '---------------------------------------------------------------------------------------------------------------------------
	      'Prfung: Bestellvorschlge oder Zulauf vorhanden?
	      '---------------------------------------------------------------------------------------------------------------------------
	      
	      iAnz_Bestellv = GetHiddenFieldContentByName("v_FakturaArtikel_Lagermenge",sFilterArtikel,"Anz_Bestellv","Der Artikel konnte nicht gefunden werden")
	      
	      iAnz_Zulauf = GetHiddenFieldContentByName("v_FakturaArtikel_Lagermenge",sFilterArtikel,"Anz_Zulauf","Der Artikel konnte nicht gefunden werden")
	      
	      iAnz_Bestellv = Stringreplace(iAnz_Bestellv,".",",")
	      iAnz_Bestellv =FormatNumber(iAnz_Bestellv,2,-1,0,-1)
	      
	      iAnz_Zulauf = Stringreplace(iAnz_Zulauf,".",",")
	      iAnz_Zulauf =FormatNumber(iAnz_Zulauf,2,-1,0,-1)
	  
	
	  	 bBestellvorschlag   = False
	            
	   
         'Bestellvorschlag
         sFrage = "Es befinden sich aktuell " & iAnz_Zulauf & " Artikel " & sArtikelnr &" im Zulauf."  &vblf &"In den Bestellvorschlgen sind " & iAnz_Bestellv &" ." &  vblf &" Soll ein Bestellvorschlag fr den Artikel " &sArtikelnr & " angelegt werden?"

         IF MsgBox(sFrage,vbQuestion + vbYesNo, "Bestellvorschlag anlegen") = vbNO Then 'Bestellvorschlag nicht anlegen
                     
	     'Es soll kein Bestellvorschlag angelegt werden
	     bBestellvorschlag = False
	     
	     Else
	     
	     'Es soll ein Bestellvorschlag angelegt werden
	     bBestellvorschlag = True
	     
	     END If ' / Bestellvorschlag nicht anlegen
	       
		 
		 
	     
	      	
		if bBestellvorschlag then 'Bestellvorschlag anlegen
                   iBestellMenge = inputBox("Wie viele Artikel " & sArtikelnr & " sollen bestellt werden?")      
	   		
			If iBestellMenge = Null or iBestellMenge = "" then
	        	  iBestellMenge = 0
	      		End If
    
    	              'Eingabe auf numerisch prfen
	              If IstZahl(iBestellMenge)= "false" Then
	               Msgbox("Bitte nur Zahlen eingeben.")
	               iBestellMenge = 0
	              End If
	      
	        
	             'Eingabe auf negativ prfen 
	             If iBestellMenge < 0 Then
	               Msgbox("Bitte nur positive Zahlenwerte eingeben.")
	               iBestellMenge = 0
	             End If
	      
	          'Eingabe formatieren
	          iBestellMenge = Stringreplace(iBestellMenge,".",",")
	          iBestellMenge =FormatNumber(iBestellMenge,2,-1,0,-1)
		
		
		  If iBestellMenge<>0 then
			'Stored Procedure: Lagerbuchung fertig setzen und eventuelle Fehler ausgeben
			 sProcedure    = "Fs_Bestellvorschlag_Anlegen"
			sTrennzeichen = ";"
			sParameter    = sArtikelnr & ";" & iBestellMenge & ";" & sBelegpos_Recordid  & ";" & sErfuser
				   
			bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "007"))
				   
			if bSP = false THEN
			'RaiseException("ErrorCode:" & sErrorCode & "007" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support") 
			Set oLagerRecordSet = Nothing
			Set oRecordSet 	 = Nothing
			Set oRecord      	 = Nothing
			End if
		  End If	
	        END IF '/ Bestellvorschlag anlegen
		 
		
	   END IF '/ Meldebestand unterschritten
	     
	END IF '/Meldebestand prfen
    Loop Until Not oRecordSet.MoveNext ' / Lagerbuchung
  END IF 'Datenstze zum Buchen vorhanden




   'Stored Procedure: Belegpos und Beleg <Lagerbuchung> setzen 
   sProcedure    = "Fs_Lagerbuchung_Fertig"
   sTrennzeichen = ";"
   sParameter    = sBeleg_Recordid
   'showmessage(sProcedure & " | " & sParameter)
   bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "008"))
   'showmessage("Beleg Fertig")
		    if bSP = false THEN
		      'RaiseException("ErrorCode:" & sErrorCode & "008" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
		      Set oLagerRecordSet = Nothing
		      Set oRecordSet 	 = Nothing
		      Set oRecord      	 = Nothing
		      Wscript.Quit
		     End If




   'Stored Procedure: Belegpos und Beleg <Lagerbuchung> setzen 
   sProcedure    = "Fs_Lagerbuchung_Beleg_Setzen"
   sTrennzeichen = ";"
   sParameter    = sBeleg_Recordid
   'showmessage(sProcedure & " | " & sParameter)
   bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "008"))
   'showmessage("Beleg setzen")
		    if bSP = false Then
		      'RaiseException("ErrorCode:" & sErrorCode & "008" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
		      Set oLagerRecordSet = Nothing
		      Set oRecordSet 	 = Nothing
		      Set oRecord      	 = Nothing
		      Wscript.Quit
		     End If
		    


   'Stored Procedure: nicht bentigte Buchungen entfernen und eventuelle Fehler ausgeben
   sProcedure    = "Fs_Lagerbuchung_Delete"
   sTrennzeichen = ";"
   sParameter    = sBeleg_Recordid
   'showmessage(sProcedure & " | " & sParameter)
   bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "009"))
   'showmessage("Lagerbuchung_Delete")
		    if bSP = false THEN
		      'RaiseException("ErrorCode:" & sErrorCode & "009" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
		      Set oLagerRecordSet = Nothing
		      Set oRecordSet 	 = Nothing
		      Set oRecord      	 = Nothing
		      Wscript.Quit
                    End If
		    
  
   'Stored Procedure: Sperre aufheben
    sProcedure    = "Fs_Lagerbuchung_Temp_Delete"
    sTrennzeichen = ";"
    sParameter    = sBeleg_Recordid & ";" & sErfuser
    'showmessage("Lagerbuchung_Temp_Delete")	
    'showmessage(sProcedure & " | " & sParameter)
    bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "010"))
   
		    if bSP = false Then
		      'RaiseException("ErrorCode:" & sErrorCode & "010" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
		      Set oLagerRecordSet = Nothing
		      Set oRecordSet 	 = Nothing
		      Set oRecord      	 = Nothing
             	      WScript.Quit
		    End if
		    
   'Stored Procedure: Auftrge zum Beleg Reservierung rckgngig 
  
   If sBeleg_Groupid <> "" Then
    sProcedure    = "Fs_Lagerbuchung_Auftrag_buchen"
    sTrennzeichen = ";"
    sParameter    = sBeleg_Groupid
    'showmessage("Reservierung Rckgngig")	
    'showmessage(sProcedure & " | " & sParameter)
    bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "011"))
   
		    if bSP = false THEN
		      'RaiseException("ErrorCode:" & sErrorCode & "011" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
		      Set oLagerRecordSet = Nothing
		      Set oRecordSet 	   = Nothing
		      Set oRecord      	   = Nothing
             	      WScript.Quit  
		    End If
     
   END IF
   	    
  'Beleg abschlieen
  sProcedure    = "Fs_Belege_Weiterfuehren"
  sTrennzeichen = ";"
  sParameter    = sBeleg_Recordid
  'showmessage("Beleg weiterfhren")  
  'showmessage(sProcedure & " | " & sParameter)
  bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "012"))
   
		    if bSP = false THEN
		      'RaiseException("ErrorCode:" & sErrorCode & "012" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
		      Set oLagerRecordSet = Nothing
		      Set oRecordSet 	   = Nothing
		      Set oRecord      	   = Nothing
             	      WScript.Quit
		     End If
		    
   MsgBox("Die Lagerbuchung wurde durchgefhrt")
   
  'Ansicht Aktualisieren
  cRm.CurrentProject.ActiveViews.ActiveView.InvokeMenu 32784,True



END IF 'Filter Korrekt



Set oLagerRecordSet = Nothing
Set oRecordSet = Nothing
Set oRecord      = Nothing

End Sub

'---------------------------------------------------------------------------------------------------------------------------
'Prozedur Vorgang beenden
'---------------------------------------------------------------------------------------------------------------------------
Sub Lagerbuchung_Beenden(BelegID,ErfUser)
' Ausfhren von Fs_Lagerbuchung_Temp_Delete und Fs_Lagerbuchung _Delete und Fs_Lagerbuchung_Sn_Rueckgaengig
  Dim sProcedure,sTrennzeichen,sParameter,bSP
 
 
 'Stored Procedure: Sperre aufheben
    sProcedure    = "Fs_Lagerbuchung_Temp_Delete"
    sTrennzeichen = ";"
    sParameter    = BelegID & ";" & ErfUser
    'showmessage(sProcedure & " | " & sParameter)		     
    bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "010"))
   
		    if bSP = false THEN
		      'RaiseException("ErrorCode:" & sErrorCode & "010" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
             	      WScript.Quit
		    End If

   'Stored Procedure: nicht bentigte Buchungen entfernen und eventuelle Fehler ausgeben
   sProcedure    = "Fs_Lagerbuchung_Delete"
   sTrennzeichen = ";"
   sParameter    = BelegID 
   'showmessage(sProcedure & " | " & sParameter)
   bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "009"))
   
		    if bSP = false THEN
		      'RaiseException("ErrorCode:" & sErrorCode & "009" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
		      Wscript.Quit
            End If
	' ------------------Wieder aktivieren!!! -----
   'Stored Procedure: Seriennumern-Zuordnung rckgngig machen
   sProcedure    = "Fs_Lagerbuchung_Sn_Rueckgaengig"
   sTrennzeichen = ";"
   sParameter    = BelegID & ";" & ErfUser
   'showmessage(sProcedure & " | " & sParameter)
   bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "011"))
   
		    if bSP = false THEN
		      'RaiseException("ErrorCode:" & sErrorCode & "011" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
		      Wscript.Quit
            End If	  
             
   'Objekte freigeben und Script beenden
   'Set oLagerRecordSet = Nothing
   'Set oRecordSet 	   = Nothing
   'Set oRecord         = Nothing
   Wscript.Quit

END Sub
'---------------------------------------------------------------------------------------------------------------------------


Function GetGuid()
  Dim TypeLib
    Set TypeLib = CreateObject("Scriptlet.TypeLib")
    GetGuid = Left(CStr(TypeLib.Guid), 38)
    Set TypeLib = Nothing
End Function
